# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DevTestLabs::Mgmt::V2018_09_15
  module Models
    #
    # A Service Fabric.
    #
    class ServiceFabric < Resource

      include MsRestAzure

      # @return [String] The backing service fabric resource's id
      attr_accessor :external_service_fabric_id

      # @return [String] The resource id of the environment under which the
      # service fabric resource is present
      attr_accessor :environment_id

      # @return [ApplicableSchedule] The applicable schedule for the virtual
      # machine.
      attr_accessor :applicable_schedule

      # @return [String] The provisioning status of the resource.
      attr_accessor :provisioning_state

      # @return [String] The unique immutable identifier of a resource (Guid).
      attr_accessor :unique_identifier


      #
      # Mapper for ServiceFabric class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ServiceFabric',
          type: {
            name: 'Composite',
            class_name: 'ServiceFabric',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: false,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              external_service_fabric_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.externalServiceFabricId',
                type: {
                  name: 'String'
                }
              },
              environment_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.environmentId',
                type: {
                  name: 'String'
                }
              },
              applicable_schedule: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.applicableSchedule',
                type: {
                  name: 'Composite',
                  class_name: 'ApplicableSchedule'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              },
              unique_identifier: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.uniqueIdentifier',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
