# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DevTestLabs::Mgmt::V2018_09_15
  module Models
    #
    # Property overrides on a subnet of a virtual network.
    #
    class SubnetOverrideFragment

      include MsRestAzure

      # @return [String] The resource ID of the subnet.
      attr_accessor :resource_id

      # @return [String] The name given to the subnet within the lab.
      attr_accessor :lab_subnet_name

      # @return [UsagePermissionType] Indicates whether this subnet can be used
      # during virtual machine creation (i.e. Allow, Deny). Possible values
      # include: 'Default', 'Deny', 'Allow'
      attr_accessor :use_in_vm_creation_permission

      # @return [UsagePermissionType] Indicates whether public IP addresses can
      # be assigned to virtual machines on this subnet (i.e. Allow, Deny).
      # Possible values include: 'Default', 'Deny', 'Allow'
      attr_accessor :use_public_ip_address_permission

      # @return [SubnetSharedPublicIpAddressConfigurationFragment] Properties
      # that virtual machines on this subnet will share.
      attr_accessor :shared_public_ip_address_configuration

      # @return [String] The virtual network pool associated with this subnet.
      attr_accessor :virtual_network_pool_name


      #
      # Mapper for SubnetOverrideFragment class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SubnetOverrideFragment',
          type: {
            name: 'Composite',
            class_name: 'SubnetOverrideFragment',
            model_properties: {
              resource_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resourceId',
                type: {
                  name: 'String'
                }
              },
              lab_subnet_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'labSubnetName',
                type: {
                  name: 'String'
                }
              },
              use_in_vm_creation_permission: {
                client_side_validation: true,
                required: false,
                serialized_name: 'useInVmCreationPermission',
                type: {
                  name: 'String'
                }
              },
              use_public_ip_address_permission: {
                client_side_validation: true,
                required: false,
                serialized_name: 'usePublicIpAddressPermission',
                type: {
                  name: 'String'
                }
              },
              shared_public_ip_address_configuration: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sharedPublicIpAddressConfiguration',
                type: {
                  name: 'Composite',
                  class_name: 'SubnetSharedPublicIpAddressConfigurationFragment'
                }
              },
              virtual_network_pool_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'virtualNetworkPoolName',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
